#pragma once
#include <atlcomcli.h>
#include <list>
#include "CppSIAPI.h"

namespace CppSample
{
	class CppSIAPITest
	{
	public:
		CppSIAPITest();
		CppSIAPITest(CppSIAPI *api);
		~CppSIAPITest();

		// A sample to create two Signals Sites and build a Freeway Diamond Interchange Network
		int CreateFreewayDiamondInterchangeNetwork();

		// A sample to read Lane Disciplines data
		int ReadLaneDisciplines();

		// A sample to read Priorities data
		int ReadPrioritiesData();

		// A sample to create a Roundabout Site, set the Lane Disciplines specifically
		int CreateRoundaboutSite();

		// A sample to create a Roundabout Site, call the method SetDefaultLaneDisciplines() to automatically set the default Lane Disciplines on all Approach Lanes
		int CreateRoundaboutSite2();

	private:
		CppSIAPI *pCppSIAPI;
		CComPtr<ISIAPI> pISIAPI;
		CComPtr<ISIAPISite> CreateSite209W(CComPtr<ISIAPIProject> project);
		CComPtr<ISIAPISite> CreateSite209E(CComPtr<ISIAPIProject> project);
		CComPtr<ISIAPINetwork> CreateNetwork(CComPtr<ISIAPIProject> project);

	};
}
